Program twodbump;

uses crt,grafx2,pnglib,stream32,gx_glob;

var

 v1,v2,img      : tgxmem;
 vi1,vi2,image  : timage;
 s              : tfilestream32;
 screen         : tgxscreen;

Procedure SetUpVirtual;
BEGIN
  openimage(vi2,640,480,screen.mode.bpp,0,imdefault);
  v1.init(vi1);
  v2.init(vi2);
  img.init(image);
END;

Procedure ShutDown;
BEGIN
  v1.close;
  v2.close;
  img.close;
END;

procedure dobump;
const
  max = 260;
var
 x,y : integer;
 vlx,vly,
 lx,ly,
 nx,ny:integer;
  difx,
  dify,
  col   : integer;
  l1    : integer;
  r,g,b  : integer;
  l      : longint;
  o,o1,o2: longint;
label stop;

begin
  lx := 320; {The starting position of the light source}
  ly := 240; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
  l1 := 0;
  repeat
    inc(l1);
    lx := round(cos(l1/13)*133+320);
    ly := round(sin(l1/23)*133+240);
    for y := 120 to 350 do
    begin
      o  := image.imagestart+99*image.pixel+y*image.bpl;
      o1 := vi1.imagestart+99*vi1.pixel+y*vi1.bpl;
      o2 := vi2.imagestart+99*vi2.pixel+y*vi2.bpl;
      for x := 100 to 510 do
      asm
               mov   ax,x
               sub   ax,lx
               mov   vlx,ax

               mov   ax,y
               sub   ax,ly
               mov   vly,ax

        db 66h;mov   ax,image.pixel.word
        db 66h;add   o.word,ax

        db 66h;mov   ax,vi1.pixel.word
        db 66h;add   o1.word,ax

        db 66h;mov   ax,vi2.pixel.word
        db 66h;add   o2.word,ax

               mov   ax,max
               mov   cx,vlx
               mov   bx,ax
               mov   dx,vly
               neg   bx
               cmp   cx,ax
               jnl   stop
               cmp   dx,ax
               jnl   stop

               cmp   cx,bx
               jng   stop
               cmp   dx,bx
               jng   stop


               mov   es,vi1.data
        db 66h;mov   di,o1.word

        db 26h,67h,8Ah,47h,01h {mov al,es:[edi+1]}
               or    al,al
               jz    stop
               xor   ah,ah
               xor   bh,bh
        db 26h,67h,8Ah,5Fh,0FFh {mov bl,es:[edi-1]}
               sub   ax,bx
               mov   nx,ax


        db 66h;mov   cx,vi1.bpl.word
        db 26h,67h,8Ah,04h,0Fh {mov al,es:[edi+ecx]}
               xor   ah,ah
               xor   bh,bh
        db 66h;sub   di,cx
        db 26h,67h,8Ah,1Fh {mov bl,es:[edi]}
               sub   ax,bx
               mov   ny,ax

               mov   ax,vlx
               sub   ax,nx
               jns   @nsx
                  neg   ax
               @nsx:
               shr   ax,1
               cmp   ax,127
               jna   @nax
                 mov   ax,127
               @nax:
               mov   bx,127
               sub   bx,ax
               jns   @nsx2
                 mov   bx,1
               @nsx2:

               mov   ax,vly
               sub   ax,ny
               jns   @nsy
                  neg   ax
               @nsy:
               shr   ax,1
               cmp   ax,127
               jna   @nay
                 mov   ax,127
               @nay:
               mov   cx,127
               sub   cx,ax
               jns   @nsy2
                 mov   cx,1
               @nsy2:
               add   bx,cx
               cmp   bx,128
               jna   stop
               mov   col,bx

               mov   es,image.data
               db 66h;mov   di,o.word
               db 26h,67h,66h,8Bh,07h {mov  eax,es:[edi]}
               db 66h;mov   l.word,ax

               mov   bx,col
               sub   bx,128
               mov   ah,0
               mov   al,byte ptr l[2]
               mul   bx
               shr   ax,5
               cmp   ax,255
               jna   @nextb
                 mov   ax,255
               @nextb:
               push  ax

               mov   al,byte ptr l[1]
               mul   bx
               shr   ax,5
               cmp   ax,255
               jna   @nextg
                 mov   ax,255
               @nextg:
               push  ax

               mov   al,byte ptr l[0]
               mul   bx
               shr   ax,5
               cmp   ax,255
               jna   @nextr
                 mov   ax,255
               @nextr:
               push  ax
               call  v2.rgb

               mov   es,vi2.data
        db 66h;mov   di,o2.word
        db 26h,67h,89h,07h {mov  es:[edi],ax}
{        db 26h,67h,89h,57h,02h {mov  es:[edi+2],dx}
      stop:
      end;
    end;
    screen.draw(0,0,vi2,drdefault);
    v2.clear;
  until keypressed;
  while keypressed do readkey;
end;

begin
  if not screen.init(640,480,clhi,mdauto) then
    writeln(gxerror,'Error while initializing video mode');
  s.init('images\bumpchn.png',stopenread);
  loadpng(s,vi1,8,lddefault);
  s.init('images\bumpimg.png',stopenread);
  loadpng(s,image,32,lddefault);
  setupvirtual;
  dobump;
  shutdown;
  screen.close;
end.

        if (vlx < max) and (vlx >- max) and (vly >- max) and (vly < max) then
        begin
        {This is some stupid way to gain speed.. if the light vector is too
        far away from the point we want to light then don't bother..it
        will probably get no light..}

          {nx := byte(v1.getpixel(x+1,y));
          if nx = 0 then continue;
          dec(nx,byte(v1.getpixel(x-1,y)));
          ny := byte(v1.getpixel(x,y+1))-byte(v1.getpixel(x,y-1));}
          asm
                   mov   es,vi1.data
            db 66h;mov   di,o2.word

            db 26h,67h,8Ah,47h,01h {mov al,es:[edi+1]}
                   or    al,al
                   jz    stop
                   xor   ah,ah
                   xor   bh,bh
            db 26h,67h,8Ah,5Fh,0FFh {mov bl,es:[edi-1]}
                   sub   ax,bx
                   mov   nx,ax


            db 66h;mov   cx,vi1.bpl.word
            db 26h,67h,8Ah,04h,0Fh {mov al,es:[edi+ecx]}
                   xor   ah,ah
                   xor   bh,bh
            db 66h;sub   di,cx
            db 26h,67h,8Ah,1Fh {mov bl,es:[edi]}
                   sub   ax,bx
                   mov   ny,ax


          end;

{Those two lines are the heart of bumping}
{We have a pixel, say x,y and we want to find how its normal vector
is facing.. (that is its slope...) normaly we would have to mess with
cos and sin and other shitty stuff but here we only care about something
like a pseudo-normal.. in other words we only care about the Sign.. that
is there are three possible pseudo normals:
1) nx<0 (Normal facing right)
   nx>0 (Normal facing left)
   nx=0 (Normal sticking out of the screen)
and its the same story with ny.. (it can be facing up,down or sticking out..}
{To find this orientation we get 2 pixels.. the one left and the one right (or
the one up and the one down for ny) and we sub.. the result is the N vector
for our point 10,10}

{The rest is easy.. we have two vectors now.. N,L.. we want their coordinates
to be as close as possible (the closer they are the more light gets the pixel}
(*
          col := abs(vlx-nx) shr 1;
          {that is what I just said written in mathematics hehehe}
          if col > 127 then col := 127;
          {Just not to overflow}
          difx := 127-col;
          {^^^^ that is the first component of the final color.. the
          light we get from the X axis}
          if difx < 0 then difx := 1;*)
          asm
            mov   ax,vlx
            sub   ax,nx
            jns   @nsx
               neg   ax
            @nsx:
            shr   ax,1
            cmp   ax,127
            jna   @nax
              mov   ax,127
            @nax:
            mov   bx,127
            sub   bx,ax
            jns   @nsx2
              mov   bx,1
            @nsx2:

            mov   ax,vly
            sub   ax,ny
            jns   @nsy
               neg   ax
            @nsy:
            shr   ax,1
            cmp   ax,127
            jna   @nay
              mov   ax,127
            @nay:
            mov   cx,127
            sub   cx,ax
            jns   @nsy2
              mov   cx,1
            @nsy2:
            add   bx,cx
            mov   col,bx
          end;

          {Now we do the same stuff for the Y axis }
(*          col := abs(vly-ny) shr 1;
         if col > 127 then col := 127;
         dify := 127-col;
        if dify < 0 then dify := 1;
        {finaly we add the two intensities and we're done..}
        col := (difx+dify) ;*)
          if (col > 128) then
          begin
  {          l := img.getpixel(x,y);
  {          col  := (col-128);
            r := (word(cl.r)*col) shr 5;if r > 255 then r := 255;
            g := (word(cl.g)*col) shr 5;if g > 255 then g := 255;
            b := (word(cl.b)*col) shr 5;if b > 255 then b := 255;}
            asm
              mov   es,image.data
              db 66h;mov   di,o.word
              db 26h,67h,66h,8Bh,07h {mov  eax,es:[edi]}
              db 66h;mov   l.word,ax

              mov   bx,col
              sub   bx,128
              mov   ah,0
              mov   al,byte ptr l[0]
              mul   bx
              shr   ax,5
              cmp   ax,255
              jna   @nextb
                mov   ax,255
              @nextb:
              mov   b,ax

              mov   al,byte ptr l[1]
              mul   bx
              shr   ax,5
              cmp   ax,255
              jna   @nextg
                mov   ax,255
              @nextg:
              mov   g,ax

              mov   al,byte ptr l[2]
              mul   bx
              shr   ax,5
              cmp   ax,255
              jna   @nextr
                mov   ax,255
              @nextr:
              mov   r,ax
            end;
  {          col := col-128;
            cl.r := cl.r shr 1+col;
            cl.g := cl.g shr 1+col;
            cl.b := cl.b shr 1+col;}
            v2.putpixel(x,y,v2.rgb(r,g,b));
          end;

        end;
        stop:
      end;
