uses grafx2,gx_glob,crt,gx_col,newfrontier,pnglib,stream32,timebase,gx_fx;

var
  buf,buf1,pr : word;
  mvnt   : integer;
  warpx  : array[1..8*64] of boolean;
  warpy  : array[1..8*64] of boolean;
  count  : integer;

  screen    : tgxscreen;
  vscreen   : tgxmem;
  im,gx2    : timage;
  s         : tfilestream32;
  htimer    : tztimer;
  ftimer    : tztimer;
  ch        : char;
  speed     : word;
  mm        : boolean;
  tex       : array[0..3] of timage;
  currtex   : timage;
  fimage    : timage;
  currimage : integer;
  destimage : integer;


procedure pp_8_lin(x,y,val1,val2 : longint;buf1,buf2 : tselector);assembler;
asm
  db 66h;mov   bx,x.word
  db 66h;cmp   bx,0
         jl    @end
  db 66h;cmp   bx,im.sizex.word
         jge   @end
  db 66h;mov   cx,im.sizex.word
  db 66h;mov   ax,y.word
  db 66h;cmp   ax,0;dw 0000h
         jl    @end
  db 66h;cmp   ax,im.sizey.word
         jge   @end
  db 66h;mul   cx
         mov   cl,val1.byte
         mov   es,buf1
  db 26h,67h,88h,0Ch,18h {mov es:[eax+ebx],cl}

         mov   cl,val2.byte
         mov   es,buf2
  db 26h,67h,88h,0Ch,18h {mov es:[eax+ebx],cl}

 @end:
end;

procedure preparetunnel;
const
  z_dec       : double = 0.7;
  ang_dec     : double = 0.7;
  max_ang     = 1024;
  precalc     = pi/(max_ang/2);

var
  x,y              : integer;
  ang,dst,z,dstinc : double;

begin
  z_dec   := 320/im.sizex*0.7;
  ang_dec := z_dec;
  z       := 207;
  ang     := max_ang-1;
  dst     := 1;
  dstinc  := 320/im.sizex*0.02;

  repeat
    x := round(z*sin(ang * precalc)*2 + im.sizex/2);
    y := round(z*cos(ang * precalc)*2 + im.sizey/2);
    ang := ang - ang_dec;
    if (ang < 0) then
    begin
      ang := ang + max_ang;
      dst := dst + dst * dstinc;
      z   := z - z_dec;
    end;
{    if (x >= 0)and(x < im.sizex)and(y >= 0)and(y < im.sizey) then
    begin
      writemem32b(ptr48(buf,y*im.sizex+x),round(dst));
      writemem32b(ptr48(buf1,y*im.sizex+x),round(dst-ang/4));
    end;}
    pp_8_lin(x,y,round(dst),round(dst-ang/4),buf,buf1);
  until (z < 0);

end;

Procedure MoveUp;
var i : integer;
Begin
  move2(ptr48(buf,0),ptr48(pr,0),im.sizex);
  for i := 1 to im.sizey-1 do
    move2(ptr48(buf,im.sizex*i),ptr48(buf,im.sizex*(i-1)),im.sizex);
  move2(ptr48(pr,0),ptr48(buf,im.sizex*(im.sizey-1)),im.sizex);
End;

Procedure MoveDown;
var i : integer;
Begin
  move2(ptr48(buf,im.sizex*(im.sizey-1)),ptr48(pr,0),im.sizex);
  for i := im.sizey-1 downto 1 do
    move2(ptr48(buf,im.sizex*(i-1)),ptr48(buf,im.sizex*i),im.sizex);
  move2(ptr48(pr,0),ptr48(buf,0),im.sizex);
End;

Procedure MoveLeft;
Begin
  move2(ptr48(buf,0),ptr48(pr,0),1);
  backmove2(ptr48(buf,1),ptr48(buf,0),im.sizex*im.sizey-1);
  move2(ptr48(pr,0),ptr48(buf,im.sizex*im.sizey-1),1);
End;

Procedure MoveRight;
Begin
{  Move(Buf^[63999],pr^[0],1);
  Move(Buf^[0],Buf^[1],200*320-1);
  Move(pr^[0],Buf^[0],1);}

{  move2(ptr48(buf,im.sizex*im.sizey-1),ptr48(pr,0),1);
  move2(ptr48(buf,0),ptr48(buf,1),im.sizex*im.sizey-1);
  move2(ptr48(pr,0),ptr48(buf,0),1);}
End;

procedure drawtunnel_8(mvnt : byte);assembler;
{var
  x : longint;
  y : word;

begin
{  for x := 0 to im.sizex*im.sizey-1 do
  begin
    y := readmem32b(ptr48(buf1,x))+(readmem32b(ptr48(buf,x))+mvnt) shl 8;
    writemem32b(ptr48(im.data,x+im.imagestart),
    readmem32b(ptr48(im2.data,im2.imagestart+y)));
  end;}
asm
  db 66h;mov   ax,im.sizex.word
  db 66h;mul   im.sizey.word
  db 66h;dec   ax
  db 66h;mov   di,ax
  db 66h;mov   si,im.imagestart.word
  db 66h;mov   bx,currtex.imagestart.word
         mov   ax,buf1
  db 8Eh,0E0h  {mov  fs,ax}
         mov   ax,buf
  db 8Eh,0E8h  {mov  gs,ax}
         mov   cl,mvnt
         mov   es,currtex.data
         push  ds
         mov   ds,im.data

  db 66h;xor   ax,ax

  @lp:
  db 64h,67h,8Ah,07h { mov  al,fs:[edi]}
  db 65h,67h,8Ah,27h { mov  ah,gs:[edi]}
         add   ah,cl

  db 26h,67h,8Ah,04h,18h { mov  al,es:[eax+ebx]}

  db 3Eh,67h,88h,04h,37h { mov  ds:[edi+esi],al}

  db 66h;dec   di
         jns   @lp
         pop   ds
end;

procedure drawtunnel_1516(mvnt : byte);assembler;
asm
  db 66h;mov   ax,im.sizex.word
  db 66h;mul   im.sizey.word
  db 66h;dec   ax
  db 66h;mov   di,ax
  db 66h;mov   si,im.imagestart.word
  db 66h;mov   bx,currtex.imagestart.word
         mov   ax,buf1
  db 8Eh,0E0h  {mov  fs,ax}
         mov   ax,buf
  db 8Eh,0E8h  {mov  gs,ax}
         mov   cl,mvnt
         mov   es,currtex.data
         push  ds
         mov   ds,im.data

  db 66h;xor   ax,ax

  @lp:
  db 64h,67h,8Ah,07h { mov  al,fs:[edi] }
  db 65h,67h,8Ah,27h { mov  ah,gs:[edi] }
         add   ah,cl

  db 26h,67h,8Bh,04h,43h { mov  ax,es:[eax*2+ebx] }

  db 3Eh,67h,89h,04h,7Eh { mov  ds:[edi*2+esi],ax }

  db 66h;dec   di
         jns   @lp
         pop   ds
end;

procedure drawtunnel_32(mvnt : byte);assembler;
asm
  db 66h;mov   ax,im.sizex.word
  db 66h;mul   im.sizey.word
  db 66h;dec   ax
  db 66h;mov   di,ax
  db 66h;mov   si,im.imagestart.word
  db 66h;mov   bx,currtex.imagestart.word
         mov   ax,buf1
  db 8Eh,0E0h  {mov  fs,ax}
         mov   ax,buf
  db 8Eh,0E8h  {mov  gs,ax}
         mov   cl,mvnt
         mov   es,currtex.data
         push  ds
         mov   ds,im.data

  db 66h;xor   ax,ax

  @lp:
  db 64h,67h,8Ah,07h { mov  al,fs:[edi] }
  db 65h,67h,8Ah,27h { mov  ah,gs:[edi] }
         add   ah,cl

  db 26h,67h,66h,8Bh,14h,83h  { mov  edx,es:[eax*4+ebx] }

  db 3Eh,67h,66h,89h,14h,0BEh { mov  ds:[edi*4+esi],edx }

  db 66h;dec   di
         jns   @lp
         pop   ds
end;

procedure generatetables;
var
  i : integer;

begin
  for i := 1 to 2*64 do
  begin
    warpx[i] := true;
    warpy[i] := (i <= 64);
  end;
  for i := 2*64+1 to 4*64 do
  begin
    warpx[i] := false;
    warpy[i] := (i > 3*64)
  end;
  for i := 4*64+1 to 6*64 do
  begin
    warpx[i] := false;
    warpy[i] := (i <= 5*64);
  end;
  for i := 6*64+1 to 8*64 do
  begin
    warpx[i] := true;
    warpy[i] := (i > 7*64);
  end
end;

procedure showhelp(col : byte);
begin
  vscreen.setfontattributes(textdefault,textdefault,textadd);
  vscreen.write(20,20,'*** Available buttons ***',vscreen.gray(col));
  vscreen.write(20,40,'[H]     This help displayment',vscreen.gray(col));
  vscreen.write(20,50,'[+/-]   Adjust tunnel speed',vscreen.gray(col));
  vscreen.write(20,60,'[1..2]  Change texture',vscreen.gray(col));
  vscreen.write(20,70,'[M]     Change mode',vscreen.gray(col));

  vscreen.write(20,90,'[ESC]   Exit',vscreen.gray(col));
end;

procedure starthelp;
begin
  htimer.start;
end;

procedure help;
begin
  if not htimer.istiming then exit;
  if (htimer.lap < 1/htimer.resolution) then
    showhelp(round(htimer.lap*htimer.resolution*128))
  else
  begin
    if (htimer.lap >= 6/htimer.resolution) then htimer.stop;
    if (htimer.istiming) then
    if (htimer.lap >= 5/htimer.resolution) then
      showhelp(round((6-htimer.lap*htimer.resolution)*128)) else
      showhelp(128);
  end;
end;


procedure fadetoimage(dest : integer);
begin
  ftimer.start;
  destimage := dest;
end;

procedure fadeimage;
begin
  if (not ftimer.istiming) then exit;
  if (ftimer.lap*ftimer.resolution >= 2) then ftimer.stop;
  if (ftimer.istiming) then
  begin
    blend(tex[currimage],tex[destimage],fimage,round((ftimer.lap/2)*ftimer.resolution*255));
    convertimage(fimage,currtex,screen.mode.bpp);
  end else
  begin
    currimage := destimage;
    convertimage(tex[currimage],currtex,screen.mode.bpp);
  end;
end;

procedure checkbuttons;
begin
  if (not keypressed) then exit;
  ch := readkey;
  case upcase(ch) of
    '+' : if (speed < 10) then inc(speed);
    '-' : if (speed > 0) then dec(speed);
    'H' : starthelp;
    'M' : mm := not mm;
    '1' : if imageopen(tex[0]) then fadetoimage(0);
    '2' : if imageopen(tex[1]) then fadetoimage(1);
    '3' : if imageopen(tex[2]) then fadetoimage(2);
    '4' : if imageopen(tex[3]) then fadetoimage(3);
  end;
end;

begin

  if not screen.init(640,480,clhi,mdauto) then
    writeln(gxerror,'Error while initializing video mode');

  htimer.init;
  ftimer.init;
  openimage(im,screen.maxx+1,screen.maxy+1,screen.mode.bpp,0,imdefault);
  getmem32(buf,im.sizex*im.sizey);
  getmem32(buf1,im.sizex*im.sizey);
  getmem32(pr,im.sizex);
  screen.write(0,0,'Please wait, generating tables...',screen.gray(255));
  generatetables;

  s.init('images\map08.png',stopenread);
  check4fail(loadpng(s,tex[0],24,lddefault));
  s.init('images\map05.png',stopenread);
  check4fail(loadpng(s,tex[1],24,lddefault));
  s.init('images\map02.png',stopenread);
  check4fail(loadpng(s,tex[2],24,lddefault));
  s.init('images\map01.png',stopenread);
  check4fail(loadpng(s,tex[3],24,lddefault));
  s.init('images\gx2sm2.png',stopenread);
  check4fail(loadpng(s,gx2,screen.mode.bpp,ldalpha));
  openimage(currtex,256,256,screen.mode.bpp,0,imdefault);
  convertimage(tex[0],currtex,screen.mode.bpp);


  preparetunnel;
  vscreen.init(im);
  speed   := 2;
  count   := 1;
  starthelp;
  repeat
    fadeimage;
    case im.bpp of
      8     : drawtunnel_8(mvnt);
      15,16 : drawtunnel_1516(mvnt);
      32    : drawtunnel_32(mvnt);
    end;
    vscreen.draw(0,vscreen.maxy-gx2.sizey,gx2,drdefault);
    help;
    screen.draw(0,0,im,drdefault);
    inc(mvnt,speed);

    if (mm) then
    begin
      case warpx[count] of
        false : moveleft;
        true  : moveright;
      end;
      case warpy[count] of
        false : movedown;
        true  : moveup;
      end;
      inc(count);
      if (count > 8*64) then count := 1;
    end;
    checkbuttons;
  until (ch = #27);
  while keypressed do readkey;

  freemem32(buf);
  freemem32(buf1);
  freemem32(pr);
  vscreen.close;
  closeimage(im);
  closeimage(currtex);
  closeimage(gx2);
  screen.close;
  ftimer.done;
  htimer.done;
  while keypressed do readkey;
end.